"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const parse_wanted_dependency_1 = __importDefault(require("@pnpm/parse-wanted-dependency"));
function default_1(resolutions) {
    const replacements = Object.entries(resolutions)
        .map(([rawWantedDependency, newPref]) => ({
        newPref,
        wantedDependency: parse_wanted_dependency_1.default(rawWantedDependency),
    }));
    return ((pkg) => {
        if (pkg.dependencies)
            replaceDeps(replacements, pkg.dependencies);
        if (pkg.optionalDependencies)
            replaceDeps(replacements, pkg.optionalDependencies);
        return pkg;
    });
}
exports.default = default_1;
function replaceDeps(replacements, deps) {
    for (const replacement of replacements) {
        if (deps[replacement.wantedDependency.alias] &&
            (!replacement.wantedDependency.pref ||
                deps[replacement.wantedDependency.alias] === replacement.wantedDependency.pref)) {
            deps[replacement.wantedDependency.alias] = replacement.newPref;
        }
    }
}
//# sourceMappingURL=createVersionsReplacer.js.map